const char FreeCADInit[] ="# FreeCAD init module\n"
"# (c) 2001 Jrgen Riegel\n"
"#\n"
"# Gathering all the information to start FreeCAD\n"
"# This is the second one of three init scripts, the third one\n"
"# runs when the gui is up\n"
"\n"
"#***************************************************************************\n"
"#*   (c) Jrgen Riegel (juergen.riegel@web.de) 2002                        *\n"
"#*                                                                         *\n"
"#*   This file is part of the FreeCAD CAx development system.              *\n"
"#*                                                                         *\n"
"#*   This program is free software; you can redistribute it and/or modify  *\n"
"#*   it under the terms of the GNU General Public License (GPL)            *\n"
"#*   as published by the Free Software Foundation; either version 2 of     *\n"
"#*   the License, or (at your option) any later version.                   *\n"
"#*   for detail see the LICENCE text file.                                 *\n"
"#*                                                                         *\n"
"#*   FreeCAD is distributed in the hope that it will be useful,            *\n"
"#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *\n"
"#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *\n"
"#*   GNU Library General Public License for more details.                  *\n"
"#*                                                                         *\n"
"#*   You should have received a copy of the GNU Library General Public     *\n"
"#*   License along with FreeCAD; if not, write to the Free Software        *\n"
"#*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  *\n"
"#*   USA                                                                   *\n"
"#*                                                                         *\n"
"#*   Juergen Riegel 2002                                                   *\n"
"#***************************************************************************/\n"
"\n"
"\n"
"# imports the one and only\n"
"import FreeCAD\n"
"\n"
"\n"
"def InitApplications():\n"
"	try:\n"
"		import sys,os,dircache\n"
"	except:\n"
"		FreeCAD.PrintError(\"\\n\\nSeems the python standard libs are not installed, bailing out!\\n\\n\")\n"
"		raise\n"
"	# Checking on FreeCAD Module path ++++++++++++++++++++++++++++++++++++++++++\n"
"	ModDir = FreeCAD.ConfigGet(\"AppHomePath\")+\'Mod\'\n"
"	ModDir = os.path.realpath(ModDir)\n"
"	#print FreeCAD.ConfigGet(\"AppHomePath\")\n"
"	if not os.path.isdir(ModDir):\n"
"		Log (\"No modules found in \" + ModDir + \"\\n\")\n"
"		return\n"
"	sys.path.append( \'..\\\\bin\' )\n"
"	sys.path.append( \'..\\\\bin\\\\Lib\' )\n"
"	sys.path.append( ModDir )\n"
"	if os.path.isdir(FreeCAD.ConfigGet(\"AppHomePath\")+\'src\\\\Tools\'):\n"
"		sys.path.append( FreeCAD.ConfigGet(\"AppHomePath\")+\'src\\\\Tools\' )\n"
"	Log(\"Using \"+ModDir+\" as module path!\\n\")\n"
"	# Searching modules dirs +++++++++++++++++++++++++++++++++++++++++++++++++++\n"
"	ModDirs = dircache.listdir(ModDir)\n"
"	AddPath = App.ConfigGet(\"AdditionalModulePaths\").split(\";\")\n"
"	for i in AddPath: ModDirs.append(i)\n"
"	#AddModPaths = App.ParamGet(\"System parameter:AdditionalModulePaths\")\n"
"	#Err( AddModPaths)\n"
"	# add also this path so that all modules search for libraries\n"
"	# they depend on first here\n"
"	BinDir = FreeCAD.ConfigGet(\"AppHomePath\")+\'bin\'\n"
"	BinDir = os.path.realpath(BinDir)\n"
"	PathExtension = BinDir + os.pathsep\n"
"	#print ModDirs\n"
"	Log(\'Init:   Searching modules...\\n\')\n"
"	ModPar = App.ParamGet(\"System parameter:Modules\")\n"
"	for Dir in ModDirs:\n"
"		if ((Dir != \'\') & (Dir != \'CVS\') & (Dir != \'__init__.py\')):\n"
"			ModGrp = ModPar.GetGroup(Dir)\n"
"			sys.path.append(os.path.join(ModDir,Dir))\n"
"			PathExtension += os.path.join(ModDir,Dir) + os.pathsep\n"
"			InstallFile = os.path.join(os.path.join(ModDir,Dir),\"Init.py\")\n"
"			if (os.path.exists(InstallFile)):\n"
"				try:\n"
"					execfile(InstallFile)\n"
"				except Exception, inst:\n"
"					Log(\'Init:      Initializing \' + Dir + \'... failed\\n\')\n"
"					Err(\'During initialization the error \' + str(inst) + \' occurred in \' + InstallFile + \'\\n\')\n"
"				else:\n"
"					Log(\'Init:      Initializing \' + Dir + \'... done\\n\')\n"
"			else:\n"
"				Log(\'Init:      Initializing \' + Dir + \'(Init.py not found)... ignore\\n\')\n"
"	# new paths must be prepended to avoid to load a wrong version of a library\n"
"	os.environ[\"PATH\"] = PathExtension + os.environ[\"PATH\"]\n"
"	path = os.environ[\"PATH\"].split(os.pathsep)\n"
"	Log(\"System path after init:\\n\")\n"
"	for i in path:\n"
"		Log(\"   \" + i + \"\\n\")\n"
"	#Log(\"path extension: \" + PathExtension + \"\\n\")\n"
"\n"
"#			else:\n"
"#				FreeCAD.PrintMessage(\'new! install it...\\n\')\n"
"#				InstallFile = os.path.join(os.path.join(ModDir,Dir),\"Install.py\")\n"
"#				if ( os.path.exists(InstallFile) ):\n"
"#					execfile(InstallFile)\n"
"#				else:\n"
"#					Wrn(\"         Install.py not found! \"+Dir+\" not installed!\\n\")\n"
"\n"
"\n"
"# some often used shortcuts (for lazy people like me ;-)\n"
"App = FreeCAD\n"
"Log = FreeCAD.Console.PrintLog\n"
"Msg = FreeCAD.Console.PrintMessage\n"
"Err = FreeCAD.Console.PrintError\n"
"Wrn = FreeCAD.Console.PrintWarning\n"
"\n"
"Log (\'Init: starting App::FreeCADInit.py\\n\')\n"
"\n"
"# init every application by importing Init.py\n"
"InitApplications()\n"
"\n"
"FreeCAD.EndingAdd(\"FreeCAD document (*.FCStd)\",\"FreeCAD\")\n"
"\n"
"# set to no gui, is overwritten by InitGui\n"
"App.GuiUp = 0\n"
"\n"
"# clean up namespace\n"
"del(InitApplications)\n"
"\n"
"Log (\'Init: App::FreeCADInit.py done\\n\')\n"
"\n"
"\n"
"\n"
"\n"
;


